%if ! 0%{?make_build:1}
%define make_build %{__make} %{?_smp_mflags}
%endif

%global username frox

Summary: Frox FTP proxy
Name: frox
Version: 0.7.18
Release: 2%{?dist}.zenetys
License: GPL
Group: System Environment/Daemons
URL: http://frox.sourceforge.net/

Source0: http://frox.sourceforge.net/download/frox-%{version}.tar.bz2
Source1: frox.service
Source2: frox.tmpfiles
Source3: frox.init
Source4: frox.conf
Source5: frox.logrotate

BuildRequires: gcc
BuildRequires: make
BuildRequires: openssl-devel
BuildRequires: perl

%if 0%{?rhel} >= 7
BuildRequires: systemd
%endif

Requires(pre): /usr/bin/getent
Requires(pre): /usr/sbin/groupadd
Requires(pre): /usr/sbin/useradd
Requires(postun): /usr/sbin/userdel

%if 0%{?rhel} >= 7
Requires(post):    systemd
Requires(preun):   systemd
Requires(postun):  systemd
%else
Requires(post):    /sbin/chkconfig
Requires(preun):   /sbin/chkconfig
Requires(preun):   /sbin/service
%endif

%description
Frox is a transparent ftp proxy which is released under the GPL.
It optionally supports caching (either through an external http
cache (eg. squid), or by maintaining a cache locally), and/or
running a virus scanner, on downloaded files. It is written with
security in mind, and in the default setup it runs as a non root
user in a chroot jail.

%prep
%setup

%build
%configure \
    --enable-configfile=/etc/frox.conf \
    --enable-ipfilter \
    --enable-http-cache \
    --enable-local-cache \
    --enable-virus-scan \
    --enable-ssl \
    --enable-transparent-data \
    --disable-libiptc \
    --enable-ccp \
    --enable-procname

%make_build
gcc -o ccp-mirrors-example doc/ccp-mirrors-example.c

%install
install -Dp -m 0755 src/frox %{buildroot}%{_sbindir}/frox

%if 0%{?rhel} >= 7
install -Dp -m 0644 %{SOURCE1} %{buildroot}%{_unitdir}/frox.service
install -Dp -m 0644 %{SOURCE2} %{buildroot}%{_tmpfilesdir}/frox.conf
%else
install -Dp -m 0755 %{SOURCE3} %{buildroot}%{_initrddir}/frox
%endif

install -Dp -m 0644 %{SOURCE4} %{buildroot}%{_sysconfdir}/frox.conf
install -Dp -m 0644 %{SOURCE5} %{buildroot}%{_sysconfdir}/logrotate.d/frox

install -Dp -m 0644 doc/frox.conf.man %{buildroot}%{_mandir}/man5/frox.conf.5
install -Dp -m 0644 doc/frox.man %{buildroot}%{_mandir}/man8/frox.8

install -Dd -m 0755 %{buildroot}%{_libexecdir}/frox
install -Dp -m 0700 doc/ccp-sizelimit-example.sh %{buildroot}%{_libexecdir}/frox/
install -Dp -m 0700 ccp-mirrors-example %{buildroot}%{_libexecdir}/frox/

install -Dd -m 0755 %{buildroot}%{_localstatedir}/lib/frox
install -Dd -m 0755 %{buildroot}%{_localstatedir}/log/frox
%if 0%{?rhel} <= 6
install -Dd -m 0755 %{buildroot}%{_localstatedir}/run/frox
%endif


%pre
/usr/bin/getent group %username >/dev/null ||
    /usr/sbin/groupadd -r %username &>/dev/null || :
/usr/bin/getent passwd %username >/dev/null ||
    /usr/sbin/useradd -r -s /sbin/nologin -d%{_localstatedir}/log/frox -M \
    -c 'Frox FTP proxy' -g %username %username &>/dev/null || :

%post
%if 0%{?rhel} >= 7
%systemd_post frox.service
%else
/sbin/chkconfig --add frox
%endif

%preun
%if 0%{?rhel} >= 7
%systemd_preun frox.service
%else
if [ $1 -eq 0 ]; then
	/sbin/service frox stop &>/dev/null || :
	/sbin/chkconfig --del frox
fi
%endif

%postun
%if 0%{?rhel} >= 7
%systemd_postun_with_restart frox.service
%endif
if [ $1 -eq 0 ]; then
	/usr/sbin/userdel %username || :
	/usr/sbin/userdel %username || :
fi

%files
%defattr(-, root, root)
%doc BUGS COPYING README
%doc doc/ChangeLog doc/CREDITS doc/FAQ* doc/IN* doc/RE* doc/SEC* doc/TODO

%{_mandir}/man5/frox.conf.5.gz
%{_mandir}/man8/frox.8.gz

%config(noreplace) %{_sysconfdir}/frox.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/frox

%if 0%{?rhel} >= 7
%{_unitdir}/frox.service
%{_tmpfilesdir}/frox.conf
%else
%{_initrddir}/frox
%endif

%{_libexecdir}/frox/ccp-mirrors-example
%{_libexecdir}/frox/ccp-sizelimit-example.sh
%{_sbindir}/frox

%defattr(-, %username, %username)
%dir %{_localstatedir}/lib/frox
%dir %{_localstatedir}/log/frox
%if 0%{?rhel} <= 6
%dir %{_localstatedir}/run/frox
%endif
